//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Red

extern ENUM_TIMEFRAMES    TimeFrame = PERIOD_CURRENT;
extern int                Length    = 20;
extern ENUM_APPLIED_PRICE Price     = PRICE_CLOSE;

//
//
//
//
//

double smooth[];
double coef[];
double nlf[];
string indicatorFileName;
bool   returnBars;

//------------------------------------------------------------------
//
//------------------------------------------------------------------

int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0,nlf);
   SetIndexBuffer(1,smooth);
   SetIndexBuffer(2,coef);
        indicatorFileName = WindowExpertName();
        returnBars        = (TimeFrame == -99);
        TimeFrame         = MathMax(TimeFrame,_Period);   
      IndicatorShortName("Ehlers non linear filter ("+Length+")");
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { nlf[0] = limit+1; return(0); }
         if (TimeFrame!=_Period)
         {
            limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period())); 
            for(int i=limit; i>=0; i--)
            {
               int y = iBarShift(NULL,TimeFrame,Time[i]);
                  nlf[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Length,Price,0,y);
            }                        
            return(0);     
         }

   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--) 
   {
      smooth[i] = (iMA(NULL,0,1,0,MODE_SMA,Price,i) + 2*iMA(NULL,0,1,0,MODE_SMA,Price,i+1) + 2*iMA(NULL,0,1,0,MODE_SMA,Price,i+2) + iMA(NULL,0,1,0,MODE_SMA,Price,i+3)) / 6.0;
      coef[i]=0; 
         for(int k=1; k<Length; k++) 
            coef[i] += (smooth[i]-smooth[i+k])*(smooth[i]-smooth[i+k]);
      
         //
         //
         //
         //
         //
         
         double num = 0, sumcoef = 0;
         for(k=0; k<Length; k++)
         {
            num     += coef[i+k]*smooth[i+k];
            sumcoef += coef[i+k];
         }
         if (sumcoef != 0) nlf[i] = num / sumcoef;
   }
   return(0);
}